/*
 * Tablero.h
 *
 *  Created on: 23/06/2011
 *      Author: antonio
 */

#ifndef TABLERO_H_
#define TABLERO_H_

#include "StdPijo.h"
#include "definitions.h"
#include <ctime>
#include <cstdlib>
#include "Casilla.h"
#include "Nivel.h"

using namespace STDP;

const int MARGENSUP = 1;
const int MARGENIZQ = 2;
const int MAXFILA = 22;
const int MAXCOLU = 77;

struct Posicion{
	int x;
	int y;
};

class Tablero {
private:
	Posicion Jugador;
	Casilla tablero[MAXFILA][MAXCOLU];
	Nivel* nivel;
	StdPijo* stdp;
	Color colorBordesTablero;
	Color colorLineasTablero;
	Color colorCursor;
	int margenSup;
	int margenIzq;
	char cursor;

	void imprimirJugador();
public:
	Tablero(StdPijo&, Nivel&, Color, Color, Color, char);
	virtual ~Tablero();

	int detectarMinas(Posicion pos);
	void sembrarMinas();
	bool moverJugador(Posicion pos);
	void imprimirTablero(bool);
	Posicion getJugador() {return Jugador;}
	void imprimirMinas();

	void setMargenSup(int margen){this->margenSup=margen;}
	void setMargenIzq(int margen){this->margenIzq=margen;}
};

#endif /* TABLERO_H_ */
